#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include "StringFieldP.h"

static XtResource resources[] = {
#define offset(f) XtOffset(StringFieldWidget, string.f)
  { XtNcallback, XtCCallback, XtRCallback, sizeof(XtCallbackList),
      offset(callback), XtRCallback, NULL },
#undef offset
};

/* ARGSUSED */
static void NotifyAction(Widget w, XEvent *e, String *params, Cardinal *num)
{
  XtCallCallbacks(w, XtNcallback, (caddr_t)e);
}

static XtActionsRec actions[] = {
  {"notify", NotifyAction},
};

static char translations[] =
"Ctrl<Key>F: forward-character() \n\
 Ctrl<Key>B: backward-character() \n\
 Ctrl<Key>D: delete-next-character() \n\
 Ctrl<Key>A: beginning-of-line() \n\
 Ctrl<Key>E: end-of-line() \n\
 Ctrl<Key>H: delete-previous-character() \n\
 Ctrl<Key>K: kill-to-end-of-line() \n\
 Ctrl<Key>L: redraw-display() \n\
 Ctrl<Key>U: select-all() kill-selection() \n\
 Meta<Key>X: select-all() kill-selection() \n\
 Meta<Key>C: select-all() kill-selection() insert-selection(SECONDARY) \n\
 Meta<Key>V: insert-selection(SECONDARY) \n\
 Shift<Key>Left: beginning-of-line() \n\
 Shift<Key>Right: end-of-line() \n\
 Shift<Key>Delete: delete-next-character() \n\
 <Key>Left: backward-character() \n\
 <Key>Right: forward-character() \n\
 <Key>Delete: delete-previous-character() \n\
 <Key>BackSpace: delete-previous-character() \n\
 <Key>Linefeed: notify() \n\
 <Key>Return: notify() \n\
 <Key>KP_Enter: notify() \n\
 <Key>: insert-char() \n\
 <FocusIn>: focus-in() \n\
 <FocusOut>: focus-out() \n\
 <Btn1Down>: select-start() \n\
 <Btn1Motion>: extend-adjust() \n\
 <Btn1Up>: extend-end(PRIMARY, CUT_BUFFER0) \n\
 <Btn2Down>: insert-selection(PRIMARY, CUT_BUFFER0) \n\
 <Btn3Down>: extend-start() \n\
 <Btn3Motion>: extend-adjust() \n\
 <Btn3Up>: extend-end(PRIMARY, CUT_BUFFER0)";

StringFieldClassRec stringFieldClassRec = {
  {
    (WidgetClass) &asciiTextClassRec,
    "StringField",
    sizeof(StringFieldRec),
    NULL,
    NULL,
    FALSE,
    NULL,
    NULL,
    XtInheritRealize,
    actions,
    XtNumber(actions),
    resources,
    XtNumber(resources),
    NULLQUARK,
    TRUE,
    TRUE,
    TRUE,
    FALSE,
    NULL,
    XtInheritResize,
    XtInheritExpose,
    NULL,
    NULL,
    XtInheritSetValuesAlmost,
    NULL,
    XtInheritAcceptFocus,
    XtVersion,
    NULL,
    translations,
    XtInheritQueryGeometry,
    XtInheritDisplayAccelerator,
    NULL
  },
  {
    XtInheritChangeSensitive
  },
  {
    0
  },
  {
    0
  },
  {
    0
  }
};

WidgetClass stringFieldWidgetClass = (WidgetClass)&stringFieldClassRec;
