#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char trietrans[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

#define VALS (sizeof(trietrans))

static struct symb {
  struct symb *next;
  char s[256];
} *tab[VALS];

static int fpos, ftab[VALS];

static int valtranslate(char c)
{
  int i;

  for(i=0; i<VALS; i++)
    if(trietrans[i] == c)
      return i;
  return VALS-1;
}

static void addsymb(char *s)
{
  struct symb *n,**p;
  int z;

  z=valtranslate(*s);
  for(p = &tab[z]; *p; p = &((*p)->next))
    if(!strcmp(s, (*p)->s))
      return;
  n=malloc(sizeof(struct symb));
  strcpy(n->s, s);
  n->next = NULL;
  *p = n;
}

static void dumptab(struct symb *s)
{
  int z;
  while(s) {
    fpos+=(z=strlen(s->s)+2);
    printf("\\%03o%s\\0", z-1, s->s);
    s=s->next;
  }
}

/* ARGSUSED */
void main(unsigned int argc, char *argv[])
{
  char s[1024], name[256];
  int val;

  for(val=0; val<VALS; val++) tab[val]=NULL;
  while(fgets(s, sizeof(s), stdin))
    if(sscanf(s,"#define XK_%s %x",name,&val)==2)
      addsymb(name);

  printf("static char __keysymtab[] =\n\"");
  fpos = 0;
  for(val=0; val<VALS; val++) {
    ftab[val] = fpos;
    dumptab(tab[val]);
    printf("\\0");
    fpos++;
  }
  printf("\";\n\nchar *keysymtab[] = {\n");
  for(val=0; val<VALS; ) {
    printf("  &__keysymtab[%d]", ftab[val]);
    if(++val<VALS) printf(",");
    printf("\n");
  }
  printf("};\n\n");
  exit(0);
  /*NOTREACHED*/
}
