#include <stdio.h>
#include <stdlib.h>

char trietrans[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_";

#define TRIEVALS (sizeof(trietrans)-1)

static int tab[TRIEVALS];

struct trie {
  struct trie *link[TRIEVALS];
  int val;
} *root;

static int howmany = 0, hm2 = 0;

struct trie *newtries()
{
  howmany ++;
  return calloc(sizeof(struct trie),1);
}

int trietranslate(char c)
{
  int i;

  for(i=0; i<TRIEVALS; i++)
    if(trietrans[i] == c)
      return i;
  return -1;
}

void addtries(struct trie *t, char *name, int val)
{
  int z;

  hm2 ++;
  if((z=trietranslate(*name))>=0)
    tab[z]++;

  while(*name) {
    if((z=trietranslate(*(name++)))<0) {
      fprintf(stderr, "\rChar \"%c\" not supported.\n", name[-1]);
      exit(10);
    }
    if(t->link[z])
      t=t->link[z];
    else
      t=t->link[z]=newtries();
  }
  t->val = val;
}

void main()
{
  char s[1024], name[256];
  int val;

  root = newtries();
  while(fgets(s, sizeof(s), stdin))
    if(sscanf(s,"#define XK_%s %x",name,&val)==2)
      addtries(root, name, val);

  fprintf(stderr,
	  "%d tries, %d strings, %d bytes used, %d chars in transtab\n",
	  howmany, hm2, howmany*sizeof(struct trie), TRIEVALS);
  for(val = 0; val<TRIEVALS; val++)
    fprintf(stderr, "%d ", tab[val]);
  fprintf(stderr, "\n");
}
